#include <Practicum.h>
#include <Servo.h> 
#include <RCSwitch.h>
#include <NewPing.h>

#define TRIGGER_PIN  PIN_PC0  // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN     PIN_PC5  // Arduino pin tied to echo pin on the ultrasonic sensor.
#define MAX_DISTANCE 200 // Maximum distance we want to ping for (in centimeters). Maximum sensor distance is rated at 400-500cm.

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE); // NewPing setup of pins and maximum distance.

RCSwitch mySwitch = RCSwitch();
Servo RightWheelServo;
Servo LeftWheelServo;
Servo FireControlServo;
void setup() {
  Serial.begin(9600);
  mySwitch.enableReceive(1);  // Receiver on inerrupt 0 => that is pin #2
}

void loop() {
  delay(50);                      // Wait 50ms between pings (about 20 pings/sec). 29ms should be the shortest delay between pings.
  unsigned int uS = sonar.ping();
  int distance = uS / US_ROUNDTRIP_CM;
  if(distance > 5 && distance < 10) {
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(180);              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(0);
      delay(1000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }
  else {
  if (mySwitch.available()) {
    
    int led_no = mySwitch.getReceivedValue();
    
    if(led_no == 119) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(0);              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(180);
      delay(5000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  } else if(led_no == 115) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(180);              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(0);
      delay(5000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  } 
  else if(led_no == 101) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(180);              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(180);
      delay(1800);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }
  else if(led_no == 113) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(0);              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(0);
      delay(2000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }
  else if(led_no == 100) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.detach();              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(180);
      delay(2000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }
  else if(led_no == 97) {                                  // in steps of 1 degree 
      LeftWheelServo.detach();
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(0);
      delay(2000);
      LeftWheelServo.detach();
      RightWheelServo.detach();      // tell servo to go to position in variable 'pos' 
  }
  else if(led_no == 99) {                                  // in steps of 1 degree 
      LeftWheelServo.attach(PIN_PC2);
      RightWheelServo.detach();              // tell servo to go to position in variable 'pos' 
      LeftWheelServo.write(0);
      delay(2000);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }
  else if(led_no == 122) {                                  // in steps of 1 degree 
      LeftWheelServo.detach();
      RightWheelServo.attach(PIN_PC3);
      RightWheelServo.write(180);
      delay(2000);
      LeftWheelServo.detach();
      RightWheelServo.detach();      // tell servo to go to position in variable 'pos' 
  }
  else if(led_no == 102){
      FireControlServo.attach(PIN_PC4);
      FireControlServo.write(0);
      delay(500);
      FireControlServo.write(180);
      delay(500);
      FireControlServo.detach();
  }
  else if(led_no == 0){
      //TestServo.write(180);
      LeftWheelServo.detach();
      RightWheelServo.detach();
  }

    mySwitch.resetAvailable();
  }
  }
}
